module VTree where

data VTree alpha = Node alpha [VTree alpha]
                   deriving Show

-- Foldr function for variadic trees:
foldT :: (alpha-> [beta]-> beta)-> VTree alpha-> beta
foldT f (Node a ns) = f a (map (foldT f) ns)

-- Map for variadic trees:
mapT :: (alpha-> beta)-> VTree alpha-> VTree beta
mapT f (Node a ns) = Node (f a) (map (mapT f) ns)
